//+---------------------------------------------------------------------+ 
//|                                                         HaDelta.mq5 | 
//|                                         Copyright  2010, Dan Valcu | 
//|                                                   www.forex-tsd.com | 
//+---------------------------------------------------------------------+
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2010, Dan Valcu"
#property link "www.forex-tsd.com" 
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    4
#property indicator_buffers 4 
//----     
#property indicator_plots   3
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//----      
#property indicator_color1 clrOrange,clrLimeGreen
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "HaDelta histogram"

//----     
#property indicator_type2 DRAW_LINE
//----     
#property indicator_color2 clrDimGray
//----   -  
#property indicator_style2 STYLE_SOLID
//----     2
#property indicator_width2 2
//----    
#property indicator_label2  "HaDelta"

//----     
#property indicator_type3 DRAW_LINE
//----     
#property indicator_color3 clrPaleVioletRed
//----   -  
#property indicator_style3 STYLE_SOLID
//----     2
#property indicator_width3 2
//----    
#property indicator_label3  "Signal Line"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA;
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input bool BetterFormula=false; // BetterFormula
input Smooth_Method Signal_Method=MODE_SMA; //   
input int Signal_XMA=3; //   
input int Signal_Phase=100; //   ,
                            //   -100 ... +100,
//    ;
//+-----------------------------------+
//----      
int min_rates_total;
//----   ,    
//      
double HaDeltaBuffer[],SignBuffer[],HistBuffer[],ColorHistBuffer[];
//+------------------------------------------------------------------+    
//| HaDelta indicator initialization function                        | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=2+XMA.GetStartBars(Signal_Method,Signal_XMA,Signal_Phase);

//----    HaDeltaBuffer   
   SetIndexBuffer(0,HistBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----     ,     
   SetIndexBuffer(1,ColorHistBuffer,INDICATOR_COLOR_INDEX);

//----    HaDeltaBuffer   
   SetIndexBuffer(2,HaDeltaBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    SignBuffer   
   SetIndexBuffer(3,SignBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----       
   XMA.XMALengthCheck("Signal_XMA",Signal_XMA);
//----       
   XMA.XMAPhaseCheck("Signal_Phase",Signal_Phase,Signal_Method);

//----      
   string shortname;
   string Smooth=XMA.GetString_MA_Method(Signal_Method);
   StringConcatenate(shortname,"HaDelta( ",BetterFormula,", ",Signal_XMA,", ",Smooth," )");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| HaDelta iteration function                                       | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----   
   int first,bar;
//----       
   double prOpen,prClose,prLow,prHigh,haClose,haOpen;
   static double haClose1,haOpen1;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      first=1; //        
      haOpen1=open[first];
      haClose1=close[first];
     }
   else //      
     {
      first=prev_calculated-1;
     }

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      prOpen=open[bar];
      prClose=close[bar];
      prLow=low[bar];
      prHigh=high[bar];

      if(BetterFormula)
        {
         if(prHigh!=prLow)haClose=(prOpen+prClose)/2.0+(((prClose-prOpen)/(prHigh-prLow))*MathAbs((prClose-prOpen)/2.0));
         else   haClose=(prOpen+prClose)/2.0;
        }
      else haClose=(prOpen+prHigh+prLow+prClose)/4;

      haOpen=(haOpen1+haClose1)/2.0;
      HaDeltaBuffer[bar]=haClose-haOpen;
      HistBuffer[bar]=HaDeltaBuffer[bar];
      if(HaDeltaBuffer[bar]>0) ColorHistBuffer[bar]=1;
      if(HaDeltaBuffer[bar]<0) ColorHistBuffer[bar]=0;
      SignBuffer[bar]=XMA.XMASeries(1,prev_calculated,rates_total,Signal_Method,Signal_Phase,Signal_XMA,HaDeltaBuffer[bar],bar,false);

      if(bar<rates_total-1)
        {
         haOpen1=haOpen;
         haClose1=haClose;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
